-- Extended Wood Harvester Cutting (Register)
-- Specialization to automatically cut trees in specified lengths
-- Version 1.0.0.0
-- @author Vector Man
-- @date 2023-01-06
-- copyright Vector Man, All Rights Reserved.

RegisterEWHC = {}
addModEventListener(RegisterEWHC)

source(g_currentModDirectory .. "src/gui/CutLengthSettingsMenu.lua")

g_specializationManager:addSpecialization('extendedWoodHarvesterCutting', 'ExtendedWoodHarvesterCutting', Utils.getFilename('src/ExtendedWoodHarvesterCutting.lua', g_currentModDirectory), nil)

function RegisterEWHC:installSpecialization(vehicleTypeManager, specializationManager)
	for vehicleName, vehicleType in pairs(vehicleTypeManager.types) do
		if SpecializationUtil.hasSpecialization(WoodHarvester, vehicleType.specializations) then
			vehicleTypeManager:addSpecialization(vehicleName, 'extendedWoodHarvesterCutting')
		end
	end
end

local function loadGui()
	g_gui:loadProfiles(Utils.getFilename("guiProfiles/guiProfiles.xml", g_currentModDirectory))
	g_cutLengthSettingsMenu = CutLengthSettingsMenu.new()
	g_gui:loadGui(Utils.getFilename("guiProfiles/cutLengthSettingsMenu.xml", g_currentModDirectory), "cutLengthSettingsMenu", g_cutLengthSettingsMenu)
end

local function validateTypes(typeManager)
    if typeManager.typeName == "vehicle" then
        RegisterEWHC:installSpecialization(g_vehicleTypeManager, g_specializationManager)
    end
end

local function init()
    TypeManager.validateTypes = Utils.prependedFunction(TypeManager.validateTypes, validateTypes)
end

loadGui()
init()