UpdateCutLengthsEvent = {}
local UpdateCutLengthsEvent_mt = Class(UpdateCutLengthsEvent, Event)

InitEventClass(UpdateCutLengthsEvent, "UpdateCutLengthsEvent")

function UpdateCutLengthsEvent.emptyNew()
	local self = Event.new(UpdateCutLengthsEvent_mt)

	return self
end

function UpdateCutLengthsEvent.new(object, lengths)
	local self = UpdateCutLengthsEvent.emptyNew()
	self.object = object
	self.lengths = lengths

	return self
end

function UpdateCutLengthsEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId)
	
	self.lengths = {}
	for i = 1, 20 do
		table.insert(self.lengths, streamReadFloat32(streamId))
	end

	self:run(connection)
end

function UpdateCutLengthsEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object)
	for i = 1, 20 do
		streamWriteFloat32(streamId, self.lengths[i])
	end
end

function UpdateCutLengthsEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(UpdateCutLengthsEvent.new(self.object, self.lengths), nil, connection, self.object)
	end

	if self.object ~= nil and self.object:getIsSynchronized() then
		self.object:updateCutLengths(self.lengths, true)
	end
end

function UpdateCutLengthsEvent.sendEvent(object, lengths, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(UpdateCutLengthsEvent.new(object, lengths), nil, false, object)
		else
			g_client:getServerConnection():sendEvent(UpdateCutLengthsEvent.new(object, lengths))
		end
	end
end
